//------------------------------------------------------
// module  : EdgeSpecif.cc
// author  : Mignotte Max
// date    : 
// version : 1.0
// language: C++
// note    :
//------------------------------------------------------
//  

//------------------------------------------------
// INCLDED FILES ---------------------------------
//------------------------------------------------
#include "EdgeSpecif.h"

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
const int ZOOM=1;
const int QUIT=0;
const int SAVE=0;
const int VISU=0;

const int ALPH=1; 
const int TAU_LAW=1;

//------------------------------------------------
// VARIABLES GLOBALES ----------------------------
//------------------------------------------------
char Name_img1[NCHAR];
char Name_img2[NCHAR];
char Extension[NCHAR];

float StGr;
int  NbIt;
float tau;
float alpha;

int  zoom;
int  flag_save;
int  flag_quit;
int  flag_visu;


//-------------------------
//--- Windows -------------
//-------------------------
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>

Display   *display;
int	  screen_num;
int 	  depth;
Window	  root;
Visual*	  visual;
GC	  gc;

/************************************************************************/
/* OPEN_DISPLAY()							*/
/************************************************************************/
int open_display()
{
  if ((display=XOpenDisplay(NULL))==NULL)
   { printf("Connection impossible\n");
     return(-1); }

  else
   { screen_num=DefaultScreen(display);
     visual=DefaultVisual(display,screen_num);
     depth=DefaultDepth(display,screen_num);
     root=RootWindow(display,screen_num);
     return 0; }
}

/************************************************************************/
/* FABRIQUE_WINDOW()							*/
/* Cette fonction cre une fenetre X et l'affiche  l'cran.	        */
/************************************************************************/
Window fabrique_window(char *nom_fen,int x,int y,int width,int height,int zoom)
{
  Window                 win;
  XSizeHints      size_hints;
  XWMHints          wm_hints;
  XClassHint     class_hints;
  XTextProperty  windowName, iconName;

  char *name=nom_fen;

  if(zoom<0) { width/=-zoom; height/=-zoom; }
  if(zoom>0) { width*=zoom;  height*=zoom;  }

  win=XCreateSimpleWindow(display,root,x,y,width,height,1,0,255);

  size_hints.flags=PPosition|PSize|PMinSize;
  size_hints.min_width=width;
  size_hints.min_height=height;

  XStringListToTextProperty(&name,1,&windowName);
  XStringListToTextProperty(&name,1,&iconName);
  wm_hints.initial_state=NormalState;
  wm_hints.input=True;
  wm_hints.flags=StateHint|InputHint;
  class_hints.res_name=nom_fen;
  class_hints.res_class=nom_fen;

  XSetWMProperties(display,win,&windowName,&iconName,
                   NULL,0,&size_hints,&wm_hints,&class_hints);

  gc=XCreateGC(display,win,0,NULL);

  XSelectInput(display,win,ExposureMask|KeyPressMask|ButtonPressMask| 
               ButtonReleaseMask|ButtonMotionMask|PointerMotionHintMask| 
               StructureNotifyMask);

  XMapWindow(display,win);
  return(win);
}

/****************************************************************************/
/* CREE_XIMAGE2()							    */
/* Cre une XImage  partir d'un tableau de float                           */
/* L'image peut subir un zoom.						    */
/****************************************************************************/
XImage* cree_Ximage2(float** mat,int z,int length,int width)
{
  int lgth,wdth,lig,col,zoom_col,zoom_lig;
  float somme;
  unsigned char	 pix;
  unsigned char* dat;
  XImage* imageX;

  /*Zoom positiv*/
  /*------------*/
  if (z>0)
  {
   lgth=length*z;
   wdth=width*z;

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<lgth;lig=lig+z) for(col=0;col<wdth;col=col+z)
   { 
    pix=(unsigned char)mat[lig/z][col/z];
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
      { 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+0)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+1)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+2)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+3)]=pix; 
       }
    }
  } /*--------------------------------------------------------*/

  /*Zoom negatifv*/
  /*------------*/
  else
  {
   z=-z;
   lgth=(length/z);
   wdth=(width/z);

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<(lgth*z);lig=lig+z) for(col=0;col<(wdth*z);col=col+z)
   {  
    somme=0.0;
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
     somme+=mat[lig+zoom_lig][col+zoom_col];
           
     somme/=(z*z);    
     dat[((lig/z)*wdth*4)+((4*(col/z))+0)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+1)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+2)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+3)]=(unsigned char)somme; 
   }
  } /*--------------------------------------------------------*/

  imageX=XCreateImage(display,visual,depth,ZPixmap,0,(char*)dat,wdth,lgth,16,wdth*4);
  return (imageX);
}

/****************************************************************************/
/* CREE_XIMAGECOUL()							    */
/* Cre une XImage  partir d'un tableau 3d de float                        */
/* L'image peut subir un zoom.						    */
/****************************************************************************/
XImage* cree_XimageCoulf(float*** matRVB,int z,int length,int width)
{
  int i;
  int lgth,wdth,lig,col,zoom_col,zoom_lig;
  float somme;
  float sum[3];
  unsigned char	 pixR,pixV,pixB,pixN;
  unsigned char* dat;
  XImage* imageX;

  /*Zoom positif*/
  /*------------*/
  if (z>0)
  {
   lgth=length*z;
   wdth=width*z;

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<lgth;lig=lig+z) for(col=0;col<wdth;col=col+z)
   { 
    pixR=(unsigned char)matRVB[0][lig/z][col/z];
    pixV=(unsigned char)matRVB[1][lig/z][col/z];
    pixB=(unsigned char)matRVB[2][lig/z][col/z];
    somme=(1.0/3.0)*(pixR+pixV+pixB);
    pixN=(unsigned char)somme;

    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
      { 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+0)]=pixB; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+1)]=pixV; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+2)]=pixR; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+3)]=0; 
       }
    }
  } /*--------------------------------------------------------*/

  /*Zoom negatif*/
  /*------------*/
  else
  {
   z=-z;
   lgth=(length/z);
   wdth=(width/z);

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<(lgth*z);lig=lig+z) for(col=0;col<(wdth*z);col=col+z)
   {  
    sum[0]=sum[1]=sum[2]=0.0;
    
    for(i=0;i<3;i++)
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
     sum[i]+=matRVB[i][lig+zoom_lig][col+zoom_col];
       
    for(i=0;i<3;i++)  sum[i]/=(z*z); 

     dat[((lig/z)*wdth*4)+((4*(col/z))+0)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+1)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+2)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+3)]=(unsigned char)sum[1]; 
   }
  } /*--------------------------------------------------------*/

  imageX=XCreateImage(display,visual,depth,ZPixmap,0,(char*)dat,wdth,lgth,16,wdth*4);
  return (imageX);
}

//---------------------------------------------------------
//---------------------------------------------------------
// Enregistre les arguments de la ligne de commande      
//---------------------------------------------------------
//---------------------------------------------------------
void read_arguments(int argc,char** argv)
{
 int i;

   //Options
  if (argc<2) 
    { printf("\n Usage   : %s [Options]",argv[0]); 
      printf("\n Options : value by default indicated in ()");
      printf("\n            -----------------------------------------");
      printf("\n            -i Nom ImgModel");
      printf("\n            -n NbIter ...........[%d]",NBITERMAX_SPEC); 
      printf("\n            -t StGrad ...........[%.5f]",STEP_GRADIENT); 
      printf("\n            -----------------------------------------");
      printf("\n            -a Distribution Law :: [%d]",TAU_LAW);
      printf("\n               [0>Uni 1>SemiGaus  2>Trg  3>Shifted Gaus 4> Exp 5-8-> Edge Class]");
      printf("\n");
      printf("\n            -l METHODE");
      printf("\n               =======");
      printf("\n");
      printf("\n                 <1>  Edge Histogram specified by a Law Model [ALGO-B-]");
      printf("\n                       >>>  Example::: %s cathedral.ppm -i cathedral.ppm -l 1 -a 1",argv[0]);
      printf("\n");
      printf("\n                 <2>  Edge Histogram specified by a Target Image [ALGO-B-C]");
      printf("\n                           -a [Neighborhood order] [Default Value:1]");
      printf("\n                                      (a=1) <=> [ALGO-B]");
      printf("\n                                      (a>1) <=> [ALGO-C]"); 
      printf("\n                       >>>  [ALGO-B] Example::: %s ImgScul1.ppm -i textureA.ppm -l 2",argv[0]);
      printf("\n                       >>>  [ALGO-C] Example::: %s ImgScul1.ppm -i textureA.ppm -l 2 -a 2",argv[0]);
      printf("\n");
      printf("\n                 <3>  Edge Histogram and Luminance Histogram specified by a Target Image [ALGO-D]"); 
      printf("\n                           -a [Neighborhood order] [Default Value:1]");
      printf("\n                       >>>  [ALGO-D] Example::: %s ImgScul1.ppm -i textureA.ppm -l 3",argv[0]); 
      printf("\n");
      printf("\n");     
      printf("\n            -----------------------------------------");
      printf("\n            -g Nom Extension");
      printf("\n            -------------");
      printf("\n            -s save (Sans)"); 
      printf("\n            -v visu (%d)",VISU);
      printf("\n            -q quit (Sans)"); 
      printf("\n            -z zoom (%d)",ZOOM);
      printf("\n            -------------\n");
      printf("\n\n\n\n\n");
      exit(-1); }

      //Chargement Fichier
      if (argc>1) strcpy(Name_img1,argv[1]);
     
   //Boucle 
   for(i=2;i<argc;i++)
     {   
          switch(argv[i][1])
          {
           case 'i': strcpy(Name_img2,argv[++i]);     break; 

           case 'n': NbIt=atoi(argv[++i]);            break; 
           case 't': StGr=atof(argv[++i]);            break; 

           case 'a': tau=atof(argv[++i]);             break; 
           case 'l': alpha=atof(argv[++i]);           break;

	   case 'g': strcpy(Extension,argv[++i]);     break;

           case 's': flag_save=1;                     break;
           case 'v': flag_visu=atoi(argv[++i]);;      break;  
           case 'q': flag_quit=1;                     break;
           case 'z': zoom=atoi(argv[++i]);            break;                 
          }    
     } 
 }

//----------------------------------------------------------
//----------------------------------------------------------
// PROGRAMME PRINCIPAL -------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
int main(int argc,char** argv)
{
 int  flag;
 int lgth1,wdth1;
 int lgth2,wdth2; 

 //Pour Xwindow
 //------------
 XEvent ev;
 Window win_ppicture_img1,win_ppicture_img2,win_ppicture_img3;
 Window win_ppicture_imghist1,win_ppicture_imghist2,win_ppicture_imghist3;
 XImage *x_ppicture_img1,*x_ppicture_img2,*x_ppicture_img3;
 XImage *x_ppicture_imghist1,*x_ppicture_imghist2,*x_ppicture_imghist3;
 char   nomfen_ppicture_img1[NCHAR],nomfen_ppicture_img2[NCHAR],nomfen_ppicture_img3[NCHAR];
 char   nomfen_ppicture_hist1[NCHAR],nomfen_ppicture_hist2[NCHAR],nomfen_ppicture_hist3[NCHAR];
 
 //Initialisation
 //--------------
 StGr=STEP_GRADIENT;
 NbIt=NBITERMAX_SPEC;

 tau=TAU_LAW; //DistributionLaw
 alpha=ALPH;  //Method
 
 zoom=ZOOM;
 flag_save=SAVE;
 flag_quit=QUIT;
 flag_visu=VISU;
 flag=0;

 //Lis Arguments
 //-------------
 read_arguments(argc,argv);

  //>Information
  //============
 printf("\n\n\n\n\n");
  printf("\n ---------------------------------------------");
  printf("\n METHODE          :: [%d]",(int)alpha);
  printf("\n Distribution Law :: [%d]",(int)tau);
  printf("\n NbIters          :: [%d]",NbIt);
  printf("\n StGrad           :: [%.3f]",StGr); 
  printf("\n ---------------------------------------------");
  printf("\n");
  fflush(stdout);
 
 //------------------------------------------
 //-------- Algorithme            -----------
 //------------------------------------------
 GetLengthWidth(Name_img1,&lgth1,&wdth1);
 GetLengthWidth(Name_img2,&lgth2,&wdth2);

 EdgeSpecif* edgdsplay=new EdgeSpecif(lgth1,wdth1,lgth2,wdth2); 

  //>Options 
  strcpy((*edgdsplay).Name_Img1,Name_img1);
  strcpy((*edgdsplay).Name_Img2,Name_img2);
  strcpy((*edgdsplay).Extension,Extension);

  (*edgdsplay).StGr=StGr;
  (*edgdsplay).NbIter=NbIt;

  (*edgdsplay).LawNumber=(int)tau;
  (*edgdsplay).Alpha=alpha;

  (*edgdsplay).flag_save=flag_save;
  (*edgdsplay).flag_visu=flag_visu; 

  //>Methode
  (*edgdsplay).Specif();
  

//---------------------------------------------------------------
//---------------- visu sous XWINDOW ----------------------------
//---------------------------------------------------------------
 if (!flag_quit)
 {
 //ouverture session graphique
 if (open_display()<0) printf(" Impossible d'ouvrir une session graphique");

 //commentaire dans les photos affichees
 sprintf(nomfen_ppicture_hist1,"Histo Input Img");
 sprintf(nomfen_ppicture_hist2,"Histo Target/Model");
 sprintf(nomfen_ppicture_hist3,"Histo Output (Specified)");
 sprintf(nomfen_ppicture_img1,"Input Image [Name: %s]",Name_img1);
 sprintf(nomfen_ppicture_img2,"Target Image [Name : %s]",Name_img2);
 sprintf(nomfen_ppicture_img3,"Output Image [%s edge specified]",Name_img1); 
  
 //creation des fenetres
 win_ppicture_imghist1=fabrique_window(nomfen_ppicture_hist1,10,10,256,256,zoom);
 win_ppicture_imghist2=fabrique_window(nomfen_ppicture_hist2,10,10,256,256,zoom);
 win_ppicture_imghist3=fabrique_window(nomfen_ppicture_hist3,10,10,256,256,zoom);
 win_ppicture_img1=fabrique_window(nomfen_ppicture_img1,10,10,(*edgdsplay).width,(*edgdsplay).length,zoom);
 win_ppicture_img2=fabrique_window(nomfen_ppicture_img2,10,10,(*edgdsplay).width2,(*edgdsplay).length2,zoom);
  win_ppicture_img3=fabrique_window(nomfen_ppicture_img3,10,10,(*edgdsplay).width,(*edgdsplay).length,zoom);
 
 //creation des Ximages
 x_ppicture_imghist1=cree_Ximage2((*edgdsplay).Hist1,zoom,256,256);
 x_ppicture_imghist2=cree_Ximage2((*edgdsplay).Hist2,zoom,256,256);
 x_ppicture_imghist3=cree_Ximage2((*edgdsplay).Hist3,zoom,256,256);
 x_ppicture_img1=cree_XimageCoulf((*edgdsplay).Imag1,zoom,(*edgdsplay).length,(*edgdsplay).width);
 x_ppicture_img2=cree_XimageCoulf((*edgdsplay).Imag2,zoom,(*edgdsplay).length2,(*edgdsplay).width2);
 x_ppicture_img3=cree_XimageCoulf((*edgdsplay).Imag3,zoom,(*edgdsplay).length,(*edgdsplay).width);

 printf("\n\n Pour quitter,appuyer sur la barre d'espace");
 fflush(stdout);

 //boucle d'evenements
  for(;;)
     {
      XNextEvent(display,&ev);
       switch(ev.type)
        {
	 case Expose:  
          XPutImage(display,win_ppicture_imghist1,gc,x_ppicture_imghist1,0,0,0,0,256,256);
          XPutImage(display,win_ppicture_imghist2,gc,x_ppicture_imghist2,0,0,0,0,256,256);
          XPutImage(display,win_ppicture_imghist3,gc,x_ppicture_imghist3,0,0,0,0,256,256);
          XPutImage(display,win_ppicture_img1,gc,x_ppicture_img1,0,0,0,0,
                   x_ppicture_img1->width,x_ppicture_img1->height);
          XPutImage(display,win_ppicture_img2,gc,x_ppicture_img2,0,0,0,0,
                   x_ppicture_img2->width,x_ppicture_img2->height);
          XPutImage(display,win_ppicture_img3,gc,x_ppicture_img3,0,0,0,0,
                   x_ppicture_img3->width,x_ppicture_img3->height);
                  
         break;

         case KeyPress: 
         XDestroyImage(x_ppicture_imghist1); 
         XDestroyImage(x_ppicture_imghist2);
         XDestroyImage(x_ppicture_imghist3);
         XDestroyImage(x_ppicture_img1); 
         XDestroyImage(x_ppicture_img2);
         XDestroyImage(x_ppicture_img3);   
         
         XFreeGC(display,gc);
         XCloseDisplay(display);
         flag=1;
         break;
         }
   if (flag==1) break;
   }
 } 
       
//--------------- fin de la session graphique --------------     
//----------------------------------------------------------

   //retour sans probleme
   //--------------------
   cout << "\n C'est fini... \n" << endl ;
   exit(-1);
   return 0;
 }
 


