//------------------------------------------------------
// module  : FunctionEdgeSpecif.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions  

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <new.h>
#include <time.h>

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
#define PI  3.14159
#define TROIS 3
#define GREY_LEVEL 255
#define BIGNUMBER    100000000

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))


/*------------------------------------------------*/
/* DEFINITIONS -----------------------------------*/
/*------------------------------------------------*/
#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//>Matrix Allocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);

//>Matrix Gestion
void  CopyMat(float**,float**,int,int); 
void  Recal(float**,int,int); 
void  RecalI(float**,int,int,float,float);
void  MultMatrix(float**,int,int,float);
float ComputeMean(float**,int,int); 
float ComputeDiff(float**,float**,int,int); 
void  Stat(float**,int,int);

//>File PGM/PPM
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,float***,int,int); 
void SaveImagePpm(char*,char*,char*,float***,int,int);

//>Conjugate Gradient 
float ComputeBeta(float**,float**,int,int);
void  AddMatrix(float**,float**,float,float**,int,int);
void  MultMatrix(float**,float,float**,int,int);
void  InitMatrix(float**,int,int);

//>Gestion Couleur
void LABToRGB(float,float,float,float*,float*,float*);
void LABToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToLAB(float,float,float,float*,float*,float*);
void Convert_LAB_TO_RGB(float***,int,int,float***);
void ConvertImgRGBToLAB(float***,float***,int,int);
void ConvertImgLABToRGB(float***,float***,int,int);

//>Sort
float randomize(void);
void  swap(float*,float*);
void  sort(float*,int,int); 
void  sort(float**,int,int,int);

//>Misc
float funcgauss(float,float,float);
void  IntMat(float**,int,int);
