//---------------------------------------------------
// module  : f_EdgeSpecif.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "EdgeSpecif.h"

//------------------------------------------------
// METHODES DE LA CLASSE EDGE_SPECIF  ------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe EdgeSpecif
//----------------------------------------------------------
EdgeSpecif::EdgeSpecif(int lgth,int wdth,int lgth2,int wdth2)           
 {
  //Initialisation 
  length=lgth;
  width=wdth;
  length2=lgth2;
  width2=wdth2;

  //Allocation Memoire Matrice  
  Imag1=fmatrix_allocate_3d(TROIS,length,width);
  Imag2=fmatrix_allocate_3d(TROIS,length2,width2);
  Imag3=fmatrix_allocate_3d(TROIS,length,width);
 
  Img1=fmatrix_allocate_2d(length,width);
  Img2=fmatrix_allocate_2d(length,width);
  Img3=fmatrix_allocate_2d(length,width);
  Img4=fmatrix_allocate_2d(length,width);
  Img5=fmatrix_allocate_2d(length,width); 
  Img6=fmatrix_allocate_2d(length,width); 
  Img7=fmatrix_allocate_2d(length,width);
  Img8=fmatrix_allocate_2d(length,width);
  Img9=fmatrix_allocate_2d(length,width);

  Hist1=fmatrix_allocate_2d(256,256);
  Hist2=fmatrix_allocate_2d(256,256);
  Hist3=fmatrix_allocate_2d(256,256);

  //Flag
  flag_save=0;
 }

//----------------------------------------------------------
// Destructeur de la classe EdgeSpecif
//----------------------------------------------------------
EdgeSpecif::~EdgeSpecif()
{ 
  //Libere Memoire Matrice 
  if (Imag1)      free_fmatrix_3d(Imag1,TROIS);
  if (Imag2)      free_fmatrix_3d(Imag2,TROIS);
  if (Imag3)      free_fmatrix_3d(Imag3,TROIS); 

  if (Img1)       free_fmatrix_2d(Img1); 
  if (Img2)       free_fmatrix_2d(Img2);
  if (Img3)       free_fmatrix_2d(Img3);
  if (Img4)       free_fmatrix_2d(Img4);
  if (Img5)       free_fmatrix_2d(Img5);
  if (Img6)       free_fmatrix_2d(Img6);
  if (Img7)       free_fmatrix_2d(Img7);
  if (Img8)       free_fmatrix_2d(Img8);
  if (Img9)       free_fmatrix_2d(Img9); 

  if (Hist1)      free_fmatrix_2d(Hist1); 
  if (Hist2)      free_fmatrix_2d(Hist2);
  if (Hist3)      free_fmatrix_2d(Hist3); 
}

//__________________________________________
//__________________________________________
//__SPECIFICATIONS EDGE HISTOGRAM___________
//__________________________________________
//__________________________________________
//----------------------------------------------------------
// Speci
//----------------------------------------------------------    
void EdgeSpecif::Specif()
{
  int k;
  int length2,width2;
  int InputSzW;

  //Load
  //====
  load_image_ppm(Name_Img1,Imag1,length,width);
  GetLengthWidth(Name_Img2,&length2,&width2);
  load_image_ppm(Name_Img2,Imag2,length2,width2); 

  //>Information
  //============
  printf("\n ---------------------------------------------");
  printf("\n Image -1-: [%s]",Name_Img1);
  printf("\n Image -2-: [%s]",Name_Img2);
  printf("\n Ext:[%s]",Extension);
  printf("\n Size -1- :[lgth:%d | wdth:%d]",length,width);
  printf("\n Size -2- :[lgth:%d | wdth:%d]",length2,width2);
  printf("\n ---------------------------------------------");
  printf("\n Methode :: [%d]",(int)Alpha);
  printf("\n  <1>  Specif [1] HistoGrad");
  printf("\n  <2>  ");
  printf("\n  <3>  ");
  printf("\n");
  printf("\n Dist. Law :: [%d]",LawNumber);
  printf("\n ---------------------------");
  printf("\n NbIters: [%d]",NbIter);
  printf("\n StGrad:  [%.3f]",StGr); 
  printf("\n ---------------------------");
  printf("\n");
  fflush(stdout);

  //AllocationMemoire
  float* HistoGradImage=fmatrix_allocate_1d(NBBIN_IMG);  
  float* HistoGradModel=fmatrix_allocate_1d(NBBIN_IMG);
  float* HistoGradTmp1=fmatrix_allocate_1d(NBBIN_IMG);
  float* HistoImage=fmatrix_allocate_1d(NBBIN_IMG);  
  float* HistoModel=fmatrix_allocate_1d(NBBIN_IMG);
  float** ImgLum1=fmatrix_allocate_2d(length,width);
  float** ImgLum2=fmatrix_allocate_2d(length2,width2); 
  float** ImgTmp1=fmatrix_allocate_2d(length,width);
  float** ImgTmp2=fmatrix_allocate_2d(length,width);
  float** ImgTmp3=fmatrix_allocate_2d(length,width);
  float*** ImgCoul1=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgCoul2=fmatrix_allocate_3d(TROIS,length,width);
  float*** ImgCoul3=fmatrix_allocate_3d(TROIS,length,width);

  //InitTime
  Chrono  chrono; chrono.reset();

  //===================================================
  //===================================================
  // EDGE SPECIFICATION FROM LAW MODEL [ALGO-B]
  //===================================================
  //===================================================
  if ((int)Alpha==1)
    {
      //>Init & Info
      Flag_SPEC=0;
      printf("\n   ==============================================================");
      printf("\n   [METHODE:1]>  Edge Specification From Law Model Number::[%d]",LawNumber);
      printf("\n   ==============================================================\n");

      //> Imag[0-1] & Luminance
      for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,1.0/256.0);
      SPEC_ConvertImgRGBToLum_(Imag1,ImgLum1,length,width);  

      //>Histo Img_Input_Luminance [Hist1]
      SPEC_ComputeGradHisto(ImgLum1,HistoGradImage,1,length,width);
      SPEC_CopyHistoInMatrixForVisu(HistoGradImage,Hist1,NBBIN_IMG);
      SPEC_ViewHisto(HistoGradImage,"EDGE HISTO_Image <BEFORE>",0);

      StGrInit=StGr;
      for(k=0;k<NbIter;k++)
        {
          //>Init & Info
          StGr=StGrInit;
          printf("\n\n\n  >>>>>>>>>>>>>> ITERATION");
          printf("[%d] (Nrj=%.2f<0.1)(Bhatta=%.2f<0.1) <<<<<<<<<<<<<<",k,NrjImg,BhatAft);

           //>Edge Specification
	   if (flag_visu!=10) SPEC_SpecifGradHistoFromMod(ImgLum1,length,width,3,CARRE(3),ImgTmp1,LawNumber,NBBIN_IMG,1);
           if (flag_visu==10) SPEC_SpecifGradHistoFromMod(ImgLum1,length,width,3,CARRE(3),ImgTmp1,LawNumber,NBBIN_IMG,0);
           CopyMat(ImgLum1,ImgTmp1,length,width);
           IntMat(ImgLum1,length,width);
           Flag_SPEC=1; 

           //>Arret
           if ((NrjImg<ENERGY_MIN)&&(BhatAft<DIST_BHATTA_MAX)) break;
	}

      //>RecalageLuminance
      SPEC_RecalSameMoyLum(Imag1,ImgLum1,length,width);

      //>Histo Imag_Specifie_Luminance [Hist3]
      SPEC_ComputeGradHisto(ImgLum1,HistoGradImage,1,length,width);
      SPEC_CopyHistoInMatrixForVisu(HistoGradImage,Hist3,NBBIN_IMG,0.1);
      SPEC_ViewHisto(HistoGradImage,"EDGE HISTO_Image <AFTER>",0);

      //>Histo Model [Hist2]
      SPEC_ComputeGradHisto(HistoGradModel,LawNumber,0.05);
      SPEC_CopyHistoInMatrixForVisu(HistoGradModel,Hist2,NBBIN_IMG,0.1);
      SPEC_ViewHisto(HistoGradModel,"EDGE HISTO_Model",0);

      //>Time
      TimeSec=chrono.elapsed(SECOND); chrono.print();
      SPEC_FillInfoProcess();
      
      //>Outputs
      for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,256.0);
      MultMatrix(ImgLum1,length,width,256.0);
      //SPEC_BuiltColorImg(Imag1,ImgLum1,length,width,Imag2,0.9);    
      SPEC_ReFindColor(ImgLum1,Imag1,Imag3,length,width);
      for(k=0;k<TROIS;k++) InitMatrix(Imag2[k],length2,width2);

      //>Sauvegarde
      if (flag_save)
         { printf("\n  Sauvegarde");
           fflush(stdout);
           SaveImagePpm(Name_Img,InfoProcess,InfoProcess,Imag3,length,width); }
    }
    //================================================================
    //===END EDGE HISTOGRAM SPECIFICATION FROM LAW MODEL==============
   


  //=========================================================
  //=========================================================
  // EDGE SPECIFICATION FROM TARGET HISTOGRAM  [ALGO-B-C-D]
  //=========================================================
  //=========================================================
  if ((int)Alpha>1)
    {
      //>Init 
      Flag_SPEC=0;
      InputSzW=(2*LawNumber)+1;

      //>Info
      printf("\n   ===================================================================");
      printf("\n   [METHODE:2]>  Edge Histogram Specification From Target Image");
      printf("\n            [Input Img>%s From Target Img>%s]",Name_Img1,Name_Img2);
      printf("\n                   [Neighborhod Order::%d   SzW::%d]",LawNumber,InputSzW);
      printf("\n   ===================================================================\n");

      //> Imag1 & Image2[0-1] & Luminance
      for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,1.0/256.0);
      for(k=0;k<TROIS;k++) MultMatrix(Imag2[k],length2,width2,1.0/256.0);
      SPEC_ConvertImgRGBToLum_(Imag1,ImgLum1,length,width);  
      SPEC_ConvertImgRGBToLum_(Imag2,ImgLum2,length2,width2);   

      //>Histo Img_Input_Luminance [Hist1]
      SPEC_ComputeGradHisto(ImgLum1,HistoGradImage,1,length,width);
      SPEC_CopyHistoInMatrixForVisu(HistoGradImage,Hist1,NBBIN_IMG);
      SPEC_ViewHisto(HistoGradImage,"EDGE HISTO_Image <BEFORE>",0);

      StGrInit=StGr;
      for(k=0;k<NbIter;k++)
        {
          //>Init & Info
          StGr=StGrInit;
          printf("\n\n\n  >>>>>>>>>>>>>> ITERATION");
          printf("[%d] (Nrj=%.2f<0.1)(Bhatta=%.2f<0.1) <<<<<<<<<<<<<<",k,NrjImg,BhatAft);

           //>Edge Specification
	   SPEC_SpecifGradHistoFromImg(ImgLum1,length,width,InputSzW,CARRE(InputSzW),ImgTmp1,ImgLum2,length2,width2,NBBIN_IMG);
           CopyMat(ImgLum1,ImgTmp1,length,width);
           IntMat(ImgLum1,length,width);
           Flag_SPEC=1; 
 
           //>Arret
           if ((NrjImg<ENERGY_MIN)&&(BhatAft<DIST_BHATTA_MAX)) break;
	}

      //>Histo Imag_Specifie_Luminance [Hist3]
      SPEC_ComputeGradHisto(ImgLum1,HistoGradImage,1,length,width);
      SPEC_CopyHistoInMatrixForVisu(HistoGradImage,Hist3,NBBIN_IMG,0.1);
      SPEC_ViewHisto(HistoGradImage,"EDGE HISTO_Image <AFTER>",0);

      //>Histo Model [Hist2]
      SPEC_ComputeGradHisto(ImgLum2,HistoGradModel,1,length2,width2);
      SPEC_CopyHistoInMatrixForVisu(HistoGradModel,Hist2,NBBIN_IMG,0.1);
      SPEC_ViewHisto(HistoGradModel,"EDGE HISTO_Target",0);

      //>Time
      TimeSec=chrono.elapsed(SECOND); chrono.print();
      SPEC_FillInfoProcess();
      
      //>Outputs
      for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,256.0);
      for(k=0;k<TROIS;k++) MultMatrix(Imag2[k],length2,width2,256.0);
      MultMatrix(ImgLum1,length,width,256.0); 

         //=[Algo. B-C]======
        if ((int)Alpha==2)     
	    { SPEC_ReFindColor(ImgLum1,Imag1,Imag3,length,width); 
              //SPEC_BuiltColorImg(Imag1,ImgLum1,length,width,Imag3,0.6); 
            }

         //=[Algo. D]=[Algo. B + EqColor]====
	 if (((int)Alpha==3)||(flag_visu==10))
	    { printf("\n   >> [Algo D] Color Specification]"); 
              SPEC_ReFindColor(ImgLum1,Imag1,Imag3,length,width); 

               for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,1.0/256.0);
               for(k=0;k<TROIS;k++) MultMatrix(Imag2[k],length2,width2,1.0/256.0);
               if (flag_visu!=10) SPEC_SpecifHistoFromImgNP(Imag3,Imag3,length,width,Imag2,length2,width2);
               if (flag_visu==10)  SPEC_SpecifColHistoFromImg2(Imag3,Imag3,length,width,Imag2,length2,width2);
               for(k=0;k<TROIS;k++) MultMatrix(Imag1[k],length,width,256.0);
               for(k=0;k<TROIS;k++) MultMatrix(Imag2[k],length2,width2,256.0);
               for(k=0;k<TROIS;k++) MultMatrix(Imag3[k],length,width,256.0); }

      //>Sauvegarde
      if (flag_save)
         { printf("\n  Sauvegarde");
           fflush(stdout);
           SaveImagePpm(Name_Img,InfoProcess,InfoProcess,Imag3,length,width); }
    }
    //================================================================
    //===END EDGE HISTOGRAM SPECIFICATION FROM TARGET IMAGE===========

  //>Liberation Memoire
  //===================
  if (HistoGradImage)  free_fmatrix_1d(HistoGradImage); 
  if (HistoGradModel)  free_fmatrix_1d(HistoGradModel);
  if (HistoGradTmp1)   free_fmatrix_1d(HistoGradTmp1);
  if (HistoImage)      free_fmatrix_1d(HistoImage); 
  if (HistoModel)      free_fmatrix_1d(HistoModel);
  if (ImgLum1)         free_fmatrix_2d(ImgLum1);
  if (ImgLum2)         free_fmatrix_2d(ImgLum2);
  if (ImgTmp1)         free_fmatrix_2d(ImgTmp1);
  if (ImgTmp2)         free_fmatrix_2d(ImgTmp2);
  if (ImgTmp3)         free_fmatrix_2d(ImgTmp3);
  if (ImgCoul1)        free_fmatrix_3d(ImgCoul1,TROIS);
  if (ImgCoul2)        free_fmatrix_3d(ImgCoul2,TROIS);
  if (ImgCoul3)        free_fmatrix_3d(ImgCoul3,TROIS);
}
